varying lowp vec4 v_color; 
varying lowp vec2 v_texCoord;
varying lowp vec4 v_maskbox; // vector is encoding mask coordinates!: umin, vmin, umax, vmax

uniform sampler2D u_texture;

#define Blend(base, blend, funcf) 		vec3(funcf(base.r, blend.r), funcf(base.g, blend.g), funcf(base.b, blend.b))
#define BlendOverlayf(base, blend) 		(base < 0.5 ? (2.0 * base * blend) : (1.0 - 2.0 * (1.0 - base) * (1.0 - blend)))
#define BlendOverlay(base, blend) 		Blend(base, blend, BlendOverlayf)

void main(void)
{
    highp vec4 texcolor = texture2D(u_texture, v_texCoord);
    gl_FragColor.rgb = BlendOverlay(texcolor, v_color);
    gl_FragColor.a = texcolor.a * v_color.a;
	// Mask values only between given umin, vmin, umax, vmax coordinates
	if (v_texCoord.x < v_maskbox.x || v_texCoord.x > v_maskbox.z || 
		v_texCoord.y < v_maskbox.y || v_texCoord.y > v_maskbox.w
	)
	{
		discard;
	}
}
